#include "main_chr2.h"

//Version2 mit gesperrten Interupts

/*
UART Baud Rate Register   AT90S4433
#define UBRR

UART Control/Status Registers
#define UCSRB							RXCIE TXCIE UDRIE RXEN TXEN CHR9 RXB8 TXB8					UCSRB
#define UCSRA							RXC TXC UDRE FE OR   MPCM 								UCSRA

UART I/O Data Register
#define UDR

 UART Status Register
#define    RXC        7
#define    TXC        6
#define    UDRE       5
#define    FE         4
#define    DOR        3
#define    MPCM       0

UART Control Register
#define    RXCIE      7
#define    TXCIE      6
#define    UDRIE      5
#define    RXEN       4
#define    TXEN       3
#define    CHR9       2
#define    RXB8       1
#define    TXB8       0

UART, Rx Complete
#define UART_RX_vect
#define SIG_UART_RECV

UART Data Register Empty
#define UART_UDRE_vect
#define SIG_UART_DATA

UART, Tx Complete
#define UART_TX_vect
#define SIG_UART_TRANS
*/


#ifdef AT90S4433			//z.B. Baud 62500 mit UBRR = 3 bei Quarz = 4000000 um die UART-Ausgabe zu beschleunigen
void uinit( void )
{
  UBRR = bauddivider;			//set baud rate
//  UBRRL = bauddivider;			//set baud rate
//  UBRRH = bauddivider >> 8;
//  UCSRA = 0;
//  UCSRC = 1<<URSEL^1<<UCSZ1^1<<UCSZ0;	//8 Bit
  UCSRB = 1<<RXEN^1<<TXEN;		//enable RX, TX
}


void uputchar( char c )
{
  cli();
//  while( (UCSRA & 1<<UDRE) == 0 );	//	ob ==1 oder ==0 ist egal, schreibt immer!!
  while( !(UCSRA & 1<<UDRE) );	//	
  UDR = c;
  sei();
}

/*
UDRE 	UART Data Register Empty
Dieses Bit wird vom AVR gesetzt, wenn ein Zeichen vom Sendedatenregister in das Send-Schieberegister bernommen wurde und der UART nun wieder bereit ist, ein neues Zeichen zum Senden aufzunehmen.
Das Bit wird automatisch gelscht, wenn ein Zeichen in das Sendedatenregister geschrieben wird.


Wenn wir nun mehrere, aufeinanderfolgende Zeichen auf die Schnittstelle ausgeben wollen, dann mssen wir mit dem nchsten Zeichen warten, 
bis das vorhergehende jeweils aus dem Datenregister in das Sende-Schieberegister bernommen wurde.

Also mu man warten, bis das Zeichen ins Sendedatenregister bernommen wurde. Dies erledigt das NACHFOLGENDE "while( !(UCSRA & 1<<UDRE) )".

*/



void uputs( const char *s )			//funktioniert 
{
  while( *s )
	{
	uputchar( *s++ );
	while( !(UCSRA & 1<<UDRE) );
	}
}


/*
void SendeString (char *szBuf)
{
    while (*szBuf) {
        outp (*szBuf, UDR);
        loop_until_bit_is_set (UDR, UDRE);
    }
}
*/

void uputsnl( const char *s )	//schreibt nur das erste Zeichen des Strings
{
  uputs( s );
  uputchar( 0x0D );
}


//Dieses Unterprogramm selbst programmiert, da ich es zum Kopieren nicht finden konnte. Kann also falsch sein.
char ugetchar( void )
{

//  while( (USR0B & 1<<UDRE) == 0 );	//2313//warte so lange UDRE-Bit Null ist. 	//Bei 1 bereit fr neues Zeichen. Dann c senden.
  while (!(UCSRA & (1<<UDRE)));	//AT90S4433
//  c= UDR;		//2313
	return (UDR);	//4433
}




#endif


#ifdef Mega8
void uinit( void )
{
  UBRRL = bauddivider;			//set baud rate
  UBRRH = bauddivider >> 8;
  UCSRA = 0;				//no U2X, MPCM
  UCSRC = 1<<URSEL^1<<UCSZ1^1<<UCSZ0;	//8 Bit
  UCSRB = 1<<RXEN^1<<TXEN;		//enable RX, TX
}


void uputchar( char c )
{
  cli();
  while( (UCSRA & 1<<UDRE) == 0 );
  UDR = c;
  sei();
}


void uputs( char *s )
{
  while( *s )
    uputchar( *s++ );
}


void uputsnl( char *s )
{
  uputs( s );
  uputchar( 0x0D );
}

#endif


#ifdef Mega168
void uinit( void )
{

  UCSR0B |= (1<<TXEN0);   //  activate UART0 TX

  UBRR0H = bauddivider >> 8;  //mega88  // store baudrate (upper byte)
  UBRR0L = bauddivider & 0xFF;		//mega88
	
	
//  UBRR0L = bauddivider;			//set baud rate
//  UBRR0H = bauddivider >> 8;
  UCSR0A = 0;				//no U2X, MPCM
  UCSR0B = (1<<RXEN0)|(1<<TXEN0);	//mega88
  UCSR0C = (1<<USBS0)|(3<<UCSZ00);	//mega88 Rahmenformat setzen
//  UCSR0C = 1<<UCSZ01^1<<UCSZ00;	//8 Bit	//Mega168 hat das URSEL-REgister anscheinend nicht
//  UCSR0B = 1<<RXEN0^1<<TXEN0;		//enable RX, TX

	/*
	URSEL: Register Select
	This bit selects between accessing the UCSRC or the UBRRH Register. It is read as one when
	reading UCSRC. The URSEL must be one when writing the UCSRC.
	*/
}


void uputchar( char c )
{
  while( (UCSR0A & 1<<UDRE0) == 0 );
  UDR0 = c;
}


void uputs( char *s )
{
  while( *s )
    uputchar( *s++ );
}


void uputsnl( char *s )
{
  uputs( s );
  uputchar( 0x0D );
}


#endif



//Mega88, von Nachttischlampe und Bootlader abgeschaut:

//#define	BAUD	19200
//#define bauddivider (uint)(XTAL / BAUD / 16 - 0.5)



//	UCSR0B |= (1<<TXEN0);   //  activate UART0 TX

//	UBRR0H = bauddivider >> 8;  //mega88  // store baudrate (upper byte)
//	UBRR0L = bauddivider & 0xFF;		//mega88
  


// UCSRB = 1<<RXEN^1<<TXEN;	//enable RX, TX	//Version vom mega8
//	UCSR0B = (1<<RXEN0)|(1<<TXEN0);	//mega88
//	UCSR0C = (1<<USBS0)|(3<<UCSZ00);	//mega88 Rahmenformat setzen



//void getchar( char c )
//{
/*
RXCn TXCn UDREn FEn DORn UPEn U2Xn MPCMn 		UCSRnA-Register

UCSRnA  USART control and status register n A
 Bit 7  RXCn: USART receive complete
This flag bit is set when there are unread data in the receive buffer and cleared when the receive
buffer is empty (that is, does not contain any unread data). If the Receiver is disabled, the
receive buffer will be flushed and consequently the RXCn bit will become zero. The RXCn Flag
can be used to generate a Receive Complete interrupt (see description of the RXCIEn bit).

(0xC2) UCSR0C UMSEL01 UMSEL00 UPM01 UPM00 USBS0 UCSZ01 /UDORD0 UCSZ00 / UCPHA0 UCPOL0 192/207
(0xC1) UCSR0B RXCIE0 TXCIE0 UDRIE0 RXEN0 TXEN0 UCSZ02 RXB80 TXB80 191
(0xC0) UCSR0A RXC0 TXC0 UDRE0 FE0 DOR0 UPE0 U2X0 MPCM0 190

*/
//  while (!(UCSR0A & (1<<UDRE0)));	//mega88
//  UDR0 = c;	//mega88
//}



//void putchar( char c )
//{
/*
This bit is set (one) when a character written to UDR is transferred to the Transmit Shift
Register. Setting of this bit indicates that the transmitter is ready to receive a new char-
acter for transmission.
*/
//  while (!(UCSR0A & (1<<UDRE0)));	//mega88
//  UDR0 = c;	//mega88
//}

